#include "fxlib.h"
#include "realtime.h"


void RTC_init()
{
	RTC.RCR2.BIT.RESET = 1; // RTCReset
	RTC.RCR2.BIT.START = 1; // RTCStart
}

int RTC_read() // return time in minutes
{
	int year, month, hour, minute;
	
	RTC.RCR1.BIT.CIE = 0;
	RTC.RCR1.BIT.CF = 0;
	
	year = (RTC.RYRCNT.BIT.Y1000 * 1000) + (RTC.RYRCNT.BIT.Y100 * 100) + (RTC.RYRCNT.BIT.Y10 * 10) + RTC.RYRCNT.BIT.Y1;
	month = (RTC.RMONCNT.BIT.M10 * 10) + RTC.RMONCNT.BIT.M1;
	hour = (RTC.RHRCNT.BIT.H10 * 10) + RTC.RHRCNT.BIT.H1;
	minute = (RTC.RMINCNT.BIT.M10 * 10) + RTC.RMINCNT.BIT.M1;
	
	return 525949*year+43829*month+60*hour+minute;
}


int RTC_realtime(int memory)
{
	int time, timeinit;
	int ret = 0;
	int file, size, i = 0, j;
	unsigned char *content;
	FONTCHARACTER filename[] = {'\\','\\','f','l','s','0','\\','P','R','G','M','2','\\','P','R','G','M','2','.','d','a','t',0};
	
	file = Bfile_OpenFile(filename, _OPENMODE_READ);
	if(file>=0) {
		size = Bfile_GetFileSize(file);
		content = (char*)malloc(size);
		Bfile_ReadFile(file, content, size, 0);
		
		time = RTC_read();
		
		do
		{
			Bfile_ReadFile(file, &j, 4, i);
			i += 8;
		} while(j!=memory && i<size);
		
		if(i<size) {
			i -= 4;
			Bfile_ReadFile(file, &timeinit, 4, i);
			Bfile_CloseFile(file);
			
			ret = time - timeinit;
		}
		else {
			Bfile_CloseFile(file);
			Bfile_DeleteFile(filename);
			
			Bfile_CreateFile(filename, size+8);
			
			file = Bfile_OpenFile(filename, _OPENMODE_WRITE);
			if(file>=0) {
				Bfile_WriteFile(file, &memory, 4);
				Bfile_WriteFile(file, &time, 4);
				Bfile_WriteFile(file, content, size);
				
				Bfile_CloseFile(file);
			}
		}
	}
	return ret;
}