#include "fxlib.h"
#include "MonochromeLib.h"
#include "basic_var.h"
#include "syscall.h"
#include <timer.h>
#include "timer.h"
#include "functions.h"
#include "ECode.h"
#include "realtime.h"
#define abs(x) (x<0?-x:x)


int loop = 1;
int cpuspeed = 0;

void timer_start()
{
	SetTimer(ID_USER_TIMER1, TIMER_DELAY, timer);
}

void timer_stop()
{
	KillTimer(ID_USER_TIMER1);
	var_reset('F');
	if(cpuspeed) Reset_Calc();
	
	/*int key;
	KillTimer(ID_USER_TIMER1);
	var_reset('F');
	Bdisp_AllClr_DDVRAM();
	PopUpWin(5);
	locate(8, 2); Print("PRGM2");
	locate(5, 3); Print("Timer stopped");
	locate(6, 5); Print("Press:[MENU]");
	ML_display_vram();
	
	if(cpuspeed) {
		while(IsKeyDown(KEY_CTRL_MENU)==0) Sleep(50);
		Reset_Calc();
	}
	else while(1) GetKey(&key);*/
}

enum {
	VOID,
	ClearVRAM, ClearScreen, DisplayVRAM,
	SaveVRAM, RestoreVRAM,
	SetContrast, GetContrast,
	SetPixel, GetPixel, DrawLine, DrawRectangle, DrawCircle, DrawFilledCircle,
	Bmp, Text, Number,
	HorizontalScroll, VerticalScroll,
	SerialOpen, SerialClose, SerialRead, SerialWrite,
	FileCreate, FileRead, FileWrite,
	MultiGetkey, CPUSpeed,
	TimerStop,
	RealTime
} Functions;


void timer()
{
	int function;
	unsigned char byte = 0;
	int read = 0;
		
	if((*(unsigned char*)0x880077B1==0x03 && !isEmulator()) || IsKeyDown(KEY_CTRL_AC)) {
		timer_stop();
		return;
	}
	
	if(loop) {
		loop = 0;
		
		function = var_toint('F');
		if(!function) {
			loop = 1;
			return;
		}
		switch(function) {
			case ClearVRAM: ML_clear_vram(); break;
			case ClearScreen: ML_clear_screen(); break;
			case DisplayVRAM: ML_display_vram(); break;
			case SaveVRAM: SaveDisp(var_toint('X')); break;
			case RestoreVRAM: RestoreDisp(var_toint('X')); break;
			case SetContrast: ML_set_contrast(var_toint('C')); break;
			case GetContrast: var_setvarint('C', F_get_contrast()); break;
			case SetPixel: ML_pixel(var_toint('X'), var_toint('Y'), var_toint('C')); break;
			case GetPixel: var_setvarint('R', ML_pixel_test(var_toint('X'), var_toint('Y'))); break;
			case DrawLine: ML_line(var_toint('X'), var_toint('Y'), var_imaginarypart_toint('X'), var_imaginarypart_toint('Y'), var_toint('C')); break;
			case DrawRectangle: ML_rectangle(var_toint('X'), var_toint('Y'), var_imaginarypart_toint('X'), var_imaginarypart_toint('Y'), 0, 0, var_toint('C')); break;
			case DrawCircle: ML_circle(var_toint('X'), var_toint('Y'), var_toint('R'), var_toint('C')); break;
			case DrawFilledCircle: ML_filled_circle(var_toint('X'), var_toint('Y'), var_toint('R'), var_toint('C')); break;
			case Bmp: F_bmp(var_toint('M'), var_toint('B'), var_toint('X'), var_toint('Y'), var_imaginarypart_toint('X'), var_imaginarypart_toint('Y'), var_toint('C')); break;
			case Text: F_text(var_toint('M'), var_toint('B'), var_toint('X'), var_toint('Y'), var_toint('C'), var_imaginarypart_toint('C')); break;
			case Number: F_number(var_toint('B'), var_toint('X'), var_toint('Y'), var_toint('C'), var_imaginarypart_toint('C')); break;
			case HorizontalScroll: ML_horizontal_scroll(var_toint('X')); break;
			case VerticalScroll: ML_vertical_scroll(var_toint('Y')); break;
			case SerialOpen: { char conf[] = {0, 9, 0, 0, 0, 0}; var_setvarint('R', Serial_Open(conf)); } break;
			case SerialClose: while(Serial_Close(0) == 5); break;
			case SerialRead: var_setvarint('R', Serial_ReadByte(&byte)); var_setvarint('B', byte); break;
			case SerialWrite: Serial_WriteByte(var_toint('B')); break;
			case FileCreate: F_file_create(var_toint('M'), var_toint('X')); break;
			case FileRead: var_setvarint('R', F_file_read(var_toint('M'), var_toint('X'), &read)); var_setvarint('B', read); break;
			case FileWrite: F_file_write(var_toint('M'), var_toint('X'), var_toint('B')); break;
			case MultiGetkey: var_setvarint('R', F_key()); break;
			case CPUSpeed : CPUSpeed_start(); break;
			case TimerStop: timer_stop(); return;
			case RealTime: var_setvarint('R', RTC_realtime(var_toint('M'))); break;
		}
		var_reset('F');
		loop = 1;
	}
}

void CPUSpeed_start()
{
	Bdisp_AllClr_DDVRAM();
	PopUpWin(5);
	locate(8, 2); Print("PRGM2");
	locate(5, 3); Print("CPUSpeed OK?");
	locate(3, 4); Print("Reset at the end");
	locate(6, 5); Print("Yes:[F1]");
	locate(6, 6); Print("No :[F6]");
	ML_display_vram();
	
	while(IsKeyDown(KEY_CTRL_F1)==0 && IsKeyDown(KEY_CTRL_F6)==0) Sleep(50);
	
	if(IsKeyDown(KEY_CTRL_F1)==1) {
		cpuspeed = 1;
		
		WDT.WTCSR.WRITE = 96; //CPUSpeedQuadruple();
		WDT.WTCNT.WRITE = 0;
		CPG.FRQCR.BIT._PFC = 3;
		CPG.FRQCR.BIT.STC = 3;
	}
	
	Bdisp_AllClr_DDVRAM();
}